#

"""
    Python Insight API

    This is an internal REST API between Python and Mosel  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech

    This material is the confidential, proprietary, unpublished property
    of Fair Isaac Corporation.  Receipt or possession of this material
    does not convey rights to divulge, reproduce, use, or allow others
    to use it without the specific written authorization of Fair Isaac
    Corporation and use must conform strictly to the license agreement.

    Copyright (c) 2020-2022 Fair Isaac Corporation. All rights reserved.
"""
#


import pprint
import re  #

import six

from xpressinsight.rest.configuration import Configuration


class InsightContext(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'insighturl': 'str',
        'dmp': 'InsightDmpContext'
    }

    attribute_map = {
        'insighturl': 'insighturl',
        'dmp': 'dmp'
    }

    def __init__(self, insighturl=None, dmp=None, local_vars_configuration=None):  #
        """InsightContext - a model defined in OpenAPI"""  #
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._insighturl = None
        self._dmp = None
        self.discriminator = None

        if insighturl is not None:
            self.insighturl = insighturl
        if dmp is not None:
            self.dmp = dmp

    @property
    def insighturl(self):
        """Gets the insighturl of this InsightContext.  # noqa: E501

        Insight server URL.  # noqa: E501

        :return: The insighturl of this InsightContext.  # noqa: E501
        :rtype: str
        """
        return self._insighturl

    @insighturl.setter
    def insighturl(self, insighturl):
        """Sets the insighturl of this InsightContext.

        Insight server URL.  # noqa: E501

        :param insighturl: The insighturl of this InsightContext.  # noqa: E501
        :type: str
        """

        self._insighturl = insighturl

    @property
    def dmp(self):
        """Gets the dmp of this InsightContext.  # noqa: E501


        :return: The dmp of this InsightContext.  # noqa: E501
        :rtype: InsightDmpContext
        """
        return self._dmp

    @dmp.setter
    def dmp(self, dmp):
        """Sets the dmp of this InsightContext.


        :param dmp: The dmp of this InsightContext.  # noqa: E501
        :type: InsightDmpContext
        """

        self._dmp = dmp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InsightContext):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InsightContext):
            return True

        return self.to_dict() != other.to_dict()
